/*
 *      p7-9.c
 *      Beispielprogramm 9, Abschnitt 7
 *      Programm zum Einlesen, alphabetischen Sortieren
 *      und Ausgeben von Eingabezeilen
 */

#include <stdio.h>

#define NULL 0
#define LINES 100       /* maximale Anzahl Zeilen */

void main(void)
{
  char *lineptr[LINES]; /* Zeiger auf Textzeilen */
  int nlines;           /* Anzahl gelesener Zeilen */
  
  if ((nlines = readlines(lineptr, LINES)) >= 0) {
    sort(lineptr, nlines);
    writelines(lineptr, nlines);
  } 
  else        
    printf ("input too big to sort\n");
    
} /* main() */
 
#define MAXLEN 1000     /* Maximallaenge einer Zeile */

/* Zeile einlesen */
int getline(char line[], int max)
{
  int c, i;
  
  i = 0;
  while (--lim > 0 && (c = getchar()) != EOF && c != '\n')
    s[i++] = c;
  if (c == '\n')
    s[i++] = c;
  s[i] = '\0';
  return(i);
  
} /* getline() */

/* Eingabezeilen einlesen um sie zu sortieren */
int readlines(char *lineptr[], int maxlines)
{
  int len, nlines;
  char *p, *malloc(), line[MAXLEN];
  
  nlines = 0;
  while ((len = getline(line, MAXLEN)) > 0)
    if (nlines >= maxlines)
      return(-1);
    else if ((p = malloc(len)) == NULL)
      return(-1);
    else {
      line[len - 1] = '\0'; /* Zeilentrenner entfernen */
      strcpy(p, line);
      lineptr[nlines++] = p;
    }
  return(nlines);

} /* readlines() */

/* Zeilen ausgeben */
void writelines(char *lineptr[], int nlines)
{
 int i;
 
  for (i = 0; i < nlines; i++)
    printf("%s\n", lineptr[i]);

} /* writelines() */

/* Zeichenketten v[0],...,[n-1] in aufsteigender Reihen- */
/* folge sortieren, es werden die Zeichenketten */
/* verglichen und ihre Zeiger entsprechend sortiert */
sort(char *v[], int n)
{
  int gap, i, j;
  char *temp;
  
  for (gap = n/2; gap > 0; gap /= 2)
    for (i = gap; i < n; i++)
      for (j = i - gap; j >= 0; j -= gap) {
	if (strcmp(v[j], v[j + gap]) <= 0)
	  break;
	temp = v[j];
	v[j] = v[j + gap];
	v[j + gap] = temp;
      }

} /* sort() */
